# -*- coding: utf-8 -*-
from openerp import models, fields, api

class ResUsers(models.Model):
    _inherit = 'res.users'

    tray_host = fields.Char(string='Dirección', default='localhost', required=True)
    tray_port = fields.Integer(string='Puerto', default=8070, required=True)
    tray_path = fields.Char(string='Recurso', default='/printers-tray', required=True)
    tray_print_directly = fields.Boolean(string='Imprimir directamente', default=True)
    action_download_pdf = fields.Boolean(string='Permitir descargar PDF', default=False)
    action_preview_pdf = fields.Boolean(string='Previsualizar PDF', default=False)

    @api.one
    def write(self, values):
        if values.get('tray_print_directly', False):
            values['action_download_pdf'] = False
            values['action_preview_pdf'] = False

        if values.get('action_download_pdf', False):
            values['tray_print_directly'] = False
            values['action_preview_pdf'] = False

        if values.get('action_preview_pdf', False):
            values['tray_print_directly'] = False
            values['action_download_pdf'] = False

        return super(ResUsers, self).write(values)
